#create a class Material
from dataclasses import dataclass



@dataclass
class Material:

    name: str
    cemicoef: float
    ccontent: float
    energy: float
    weight: float

# method to estimate C content of a material
    def calculate_cstorage(self):
        cstorage= self.ccontent * self.weight
#        print("Storage =", self.ccontent * self.weight, "kgC")
        return cstorage

# method to estimate C emissions of a material
    def calculate_cemissions(self):
        cemission = self.cemicoef/3.67 * self.weight
#        print("Emissions =", cemission, "kgC")
        return cemission

# create object of Material class and initialize it with values
timber = Material(name='CLT',cemicoef = 0.2,ccontent = 0.5,energy=0,weight = 1000)
# timber.cemicoef = 0.2  # kgCO2 eq per t material
# timber.ccontent = 0.5      # kg C per kg material
# timber.weight = 1000       # kg

steel = Material(name='CLT',cemicoef = 1.34,ccontent = 0.0004,energy=0,weight = 1000)
# create object of Material class and initialize it with values
#steel = Material()
#steel.cemicoef = 1.34  # kgCO2 eq per t material
#steel.ccontent = 0.0004      # kg C per kg material
#steel.weight = 100       # kg

# access method inside class
timber.calculate_cemissions()
timber.calculate_cstorage()
#print(timber)

class Transport:
    def __init__(self, name, distance, weight, cemicoef, energy):
        self.name = name
        self.cemicoef = cemicoef
        self.energy = energy
        self.distance = distance
        self.weight = weight
    def calculate_transportemiss():
        print("Emissions =", Transport.distance * Transport.weight * Transport.cemicoef/3.67, "kgC")

# create a class Infrastruture
class Infrastructre:
    def __init__(self, name, age, floorarea, inhabitants, materials: list[Material], transportation: list(Transport)):
        self.name = name
        self.age = age
        self.inhabitants = inhabitants
        self.floorarea = floorarea
        self.materials = materials
        self.transport = transportation

# method to estimate C storage of an infrastructure
    def calculate_cstorage(self):
        print("Storage =", Material.Cstorage * Material.Cstorage, "kgC")
        sum = 0.
        for material in self.materials:
            sum += material.calculate_cemissions()
        return sum

# method to estimate C emissions of a material       
    def calculate_cemissionsTotal():
        print("Total Emissions =", Material.Cemissions + Transport.Cemissions, "kgC")
# method to estimate C emissions of a material       
    def calculate_cstoragepercapita():
        print("Carbon Storage per Capita =", Material.Cemissions + Transport.Cemissions, "kgC")  
    


Tegel = Infrastructre("Regel1", 100, [timber, steel])